//+------------------------------------------------------------------+
//| Trend Monitor                            T.Harris                |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Gray

double G_ibuf_76[];
double G_ibuf_80[];
double G_ibuf_84[];
int G_color_88 = Lime;
int G_color_92 = Red;
int G_color_96 = Gray;
extern int bar_limit = 500;
string Gs_104;

int init() {
   IndicatorDigits(Digits);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(0, G_ibuf_76);
   SetIndexBuffer(1, G_ibuf_80);
   SetIndexBuffer(2, G_ibuf_84);
   SetIndexEmptyValue(0, 0);
   SetIndexEmptyValue(1, 0);
   SetIndexEmptyValue(2, 0);
   Gs_104 = "Trend Monitor";
   IndicatorShortName(Gs_104);
   SetIndexLabel(0, Gs_104);
   return (0);
}

int start() {
   bool Li_16;
   if (Bars <= bar_limit) bar_limit = Bars;
   for (int index_4 = 0; index_4 < bar_limit - 2; index_4++) {
      if (High[index_4] > High[index_4 + 1] && High[index_4] > High[index_4 + 2] && High[index_4] > High[index_4 + 3]) {
         G_ibuf_76[index_4] = High[index_4] - (High[index_4 + 3]);
         G_ibuf_80[index_4] = 0;
         G_ibuf_84[index_4] = 0;
      } else {
         if (Low[index_4] < Low[index_4 + 1] && Low[index_4] < Low[index_4 + 2] && Low[index_4] < Low[index_4 + 3]) {
            G_ibuf_80[index_4] = Low[index_4 + 3] - Low[index_4];
            G_ibuf_76[index_4] = 0;
            G_ibuf_84[index_4] = 0;
         } else {
            G_ibuf_76[index_4] = 0;
            G_ibuf_80[index_4] = 0;
            G_ibuf_84[index_4] = MathAbs(Close[index_4] - (Close[index_4 + 3]));
         }
      }
   }
   int count_8 = 0;
   int count_12 = 0;
   for (index_4 = 0; index_4 < 250; index_4++) {
      if (G_ibuf_76[index_4] > 0.0) {
         Li_16 = TRUE;
         for (int Li_0 = index_4 + 1; Li_0 < index_4 + 6; Li_0++) {
            if (G_ibuf_76[Li_0] > G_ibuf_76[index_4] || G_ibuf_80[Li_0] > G_ibuf_76[index_4]) {
               Li_16 = FALSE;
               break;
            }
         }
         if (index_4 > 0) {
            for (Li_0 = index_4 - 1; Li_0 >= 0 && Li_0 > index_4 - 6; Li_0--) {
               if (G_ibuf_76[Li_0] > G_ibuf_76[index_4] || G_ibuf_80[Li_0] > G_ibuf_76[index_4]) {
                  Li_16 = FALSE;
                  break;
               }
            }
         }
         if (Li_16) count_8++;
      } else {
         if (G_ibuf_80[index_4] > 0.0) {
            Li_16 = TRUE;
            for (Li_0 = index_4 + 1; Li_0 < index_4 + 6; Li_0++) {
               if (G_ibuf_76[Li_0] > G_ibuf_80[index_4] || G_ibuf_80[Li_0] > G_ibuf_80[index_4]) {
                  Li_16 = FALSE;
                  break;
               }
            }
            if (index_4 > 0) {
               for (Li_0 = index_4 - 1; Li_0 >= 0 && Li_0 > index_4 - 6; Li_0--) {
                  if (G_ibuf_76[Li_0] > G_ibuf_80[index_4] || G_ibuf_80[Li_0] > G_ibuf_80[index_4]) {
                     Li_16 = FALSE;
                     break;
                  }
               }
            }
            if (Li_16) count_12++;
         }
      }
   }
   string Ls_20 = "NO ENTRY";
   color color_28 = G_color_96;
   if (count_8 > count_12) {
      color_28 = G_color_88;
      Ls_20 = "B";
   } else {
      if (count_12 > count_8) {
         color_28 = G_color_92;
         Ls_20 = "B";
      }
   }
   ObjectCreate("overall_b_tr_mon", OBJ_LABEL, WindowFind(Gs_104), Time[0], 0);
   ObjectSet("overall_b_tr_mon", OBJPROP_XDISTANCE, 5);
   ObjectSet("oberall_b_tr_mon", OBJPROP_XDISTANCE, 5);
   ObjectSet("oberall_b_tr_mon", OBJPROP_CORNER, 1);
   ObjectSetText("overall_b_tr_mon", Ls_20 + "", 14, "Arial Black", color_28);
   return (0);
}
